package server

import (
	"context"
	"errors"
	omanager "github.com/odysseus/odysseus-protocol/gen/proto/go/nodemanager/v1"
)

var (
	ErrParams    = errors.New("invalid request")
	ErrUnSupport = errors.New("unsupport feature")
)

type NodeManagerService struct {
	node *Node
	quit chan struct{}
	omanager.UnimplementedNodeManagerServiceServer
}

func (n *NodeManagerService) ManagerList(ctx context.Context, request *omanager.ManagerListRequest) (*omanager.ManagerListResponse, error) {
	list := n.node.registry.GetNodeManagerList(nil)
	res := new(omanager.ManagerListResponse)
	res.Managers = make([]omanager.NodeManagerInfo, 0, len(list))
	for _, v := range list {
		res.Managers = append(res.Managers, omanager.NodeManagerInfo{
			Publickey: v.Pubkey,
			Endpoint:  v.Endpoint,
		})
	}
	return res, nil
}

func (n *NodeManagerService) RegisterWorker(worker omanager.NodeManagerService_RegisterWorkerServer) error {
	//workerHandler := func() {
	//	for {
	//		select {
	//		case <-n.quit:
	//			return
	//		default:
	//			msg, err := worker.Recv()
	//			if err != nil {
	//				log.WithError(err).WithField("worker", "wwww").Error("recv msg failed")
	//				return
	//			}
	//		}
	//	}
	//}
	return nil

}

func (n *NodeManagerService) DispatchTask(ctx context.Context, request *omanager.DispatchTaskRequest) (*omanager.DispatchTaskResponse, error) {
	//TODO implement me
	panic("implement me")
}
